<nav class="navbar navbar-light">
  <span class="navbar-brand mb-0 h1">Estimate Table {{projectName}}</span>
</nav>
<div *ngIf="noDevelopersOnProject" class="text-danger ml-3">
  No developers on project! Default work day on project = 8 hours
</div>
<div *ngIf="dragDisabled" class="text-danger ml-3 mt-3">
  Drag and Drop disabled on mobile screen!
</div>
<div *ngIf="!tableLoaded" class="lds-dual-ring"></div>
<div [hidden]="!tableLoaded" class="content">
  <div class="flex filter-button-group">
    <div class="mr-2 inline-display" role="group" aria-label="First group">
      <div *ngIf="extendedFunctionality" class="btn-group">
        <button matTooltip="Export" mat-icon-button class="action-btn" (click)="openDialog(exportSettings)">
          <mat-icon class="plus">arrow_upward</mat-icon>
        </button>
        <button matTooltip="Import" mat-icon-button class="action-btn" (click)="fileInput.click()">
          <mat-icon class="plus">arrow_downward</mat-icon>
          <input hidden type="file" #fileInput id="input-file" (change)="onImportFileChange($event)" multiple="false">
        </button>
      </div>
    </div>
    <div class="d-flex filter-button-group">
      <div class="d-flex mobile-spacing">
        <button *ngIf="extendedFunctionality" matTooltip="Poker Planning"
          (click)="openPockerPlanningDialog(pokerPlanningDialog)" mat-icon-button class="action-btn" type="button">
          <mat-icon>casino</mat-icon>
        </button>
        <button matTooltip="Gantt Chart" mat-icon-button class="action-btn" (click)="onChartClick()" type="button">
          <mat-icon class="plus">format_align_left</mat-icon>
        </button>
        <button *ngIf="extendedFunctionality" type="button"
          [disabled]="dataSource.data.length && sortedLength !== coreLength" matTooltip="Save Order & Recount Dates"
          mat-icon-button class="action-btn" (click)="onSavePositions()">
          <mat-icon class="plus">refresh</mat-icon>
        </button>
        <button *ngIf="extendedFunctionality" type="button" mat-icon-button class="btn-delete" (click)="onDeleteTasks()"
          matTooltip="Delete tasks">
          <mat-icon class="plus">clear</mat-icon>
        </button>
        <button *ngIf="extendedFunctionality" type="button" matTooltip="Add Task" mat-icon-button class="action-btn"
          (click)="openDialog(addTaskDialog)">
          <mat-icon class="plus">add</mat-icon>
        </button>
      </div>
      <div class="mobile-spacing">
        <app-input-filter (changeEvent)="applyFilter($event)" [placeholder]='filerPlaceholder'></app-input-filter>
      </div>
    </div>
  </div>
  <div class="mat-elevation-z8 table-container">
    <table matTableExporter [hiddenColumns]="hiddenColumnsIndexArr" id="table" #exporter="matTableExporter" mat-table
      cdkDropList [dataSource]="dataSource" matSort class="w-100 table-min-width"
      (cdkDropListDropped)="dropTable($event)" [cdkDropListData]="dataSource.data">
      <ng-container matColumnDef="select">
        <th mat-header-cell *matHeaderCellDef class="pt-2">
          <mat-checkbox (change)="$event ? masterToggle() : null" [checked]="selection.hasValue() && isAllSelected()"
            [indeterminate]="selection.hasValue() && !isAllSelected()" [aria-label]="checkboxLabel()">
          </mat-checkbox>
        </th>
        <td mat-cell *matCellDef="let row" class="pt-2">
          <mat-checkbox (click)="$event.stopPropagation()" (change)="$event ? selection.toggle(row.taskId) : null"
            [checked]="selection.isSelected(row.taskId)" [aria-label]="checkboxLabel(row)">
          </mat-checkbox>
        </td>
        <td mat-footer-cell *matFooterCellDef> </td>
      </ng-container>

      <ng-container matColumnDef="taskId">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Task Id </th>
        <td mat-cell *matCellDef="let row">{{row.taskId}}</td>
        <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>

      <ng-container matColumnDef="taskName">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Name </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <div class="cursor-pointer" *ngIf="i!=currentRowIndex || 'taskName' != currentColumn"
            (dblclick)="doubleClick(i, 'taskName', row.taskId)">
            {{row.taskName}}
          </div>
          <div *ngIf="i===currentRowIndex && 'taskName' === currentColumn">
            <input type="text" class="edit-input" #editData="ngModel" ngModel="{{row.taskName}}">
            <button mat-icon-button class="btn-edit" (click)="saveEditCell(row.taskId,editData.control.value)">
              <i class="material-icons">
                done
              </i>
            </button>
            <button mat-icon-button class="btn-cancel" (click)="cancelEditCell()">
              <i class="material-icons">
                clear
              </i>
            </button>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef> Total </td>
      </ng-container>

      <ng-container matColumnDef="assignedId">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Assignee </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <span class="cursor-pointer" *ngIf="i!=currentRowIndex || 'assignedId' != currentColumn"
            (dblclick)="doubleClick(i, 'assignedId', row.taskId)">
            {{row.username}}</span>
          <div class="cursor-pointer" *ngIf="i===currentRowIndex && 'assignedId' === currentColumn"
            class="assignee-cell">
            <ng-select class="bl-select pl-3 d-inline-block" [multiple]="false" #editData="ngModel"
              [(ngModel)]="assignedUserId">
              <ng-option *ngFor="let user of users" [value]="user.userId">{{user.firstName}} {{user.lastName}}
              </ng-option>
            </ng-select>
            <div>
              <button mat-icon-button class="btn-edit in-table-button"
                (click)="saveEditCell(row.taskId,editData.control.value)">
                <i class="material-icons">
                  done
                </i>
              </button>
              <button mat-icon-button class="btn-cancel in-table-button" (click)="cancelEditCell()">
                <i class="material-icons">
                  clear
                </i>
              </button>
            </div>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef> </td>
      </ng-container>

      <ng-container matColumnDef="blockedBy">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Blocked by </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <div class="cursor-pointer" *ngIf="i!=currentRowIndex || 'blockedBy' != currentColumn"
            (dblclick)="doubleClick(i, 'blockedBy', row.taskId); loadBlockersInput(row.taskBlockers)">
            <span class="cursor-pointer" *ngIf="row.taskBlockers.length === 0"> Add </span>
            <span class="cursor-pointer" *ngFor="let blocker of row.taskBlockers"
              [matTooltip]="getBlockerName(blocker.taskBlockerId)" [matTooltipPosition]="position.value">
              #{{blocker.taskBlockerId}}
            </span>
          </div>
          <div *ngIf="i===currentRowIndex && 'blockedBy' === currentColumn">
            <ng-select class="bl-select pl-3 d-inline-block" [multiple]="true" bindLabel="taskBlockerName"
              bindValue="taskBlockerId" [(ngModel)]="editBlockersIdArray" (change)="blockersChangesChecker()">
              <ng-option *ngFor="let task of availableTaskBlockers" [value]="task.taskId">
                {{task.taskName}}</ng-option>
            </ng-select>
            <button mat-icon-button class="btn-edit in-table-button" (click)="saveBlockers(row.taskId)">
              <i class="material-icons">
                done
              </i>
            </button>
            <button mat-icon-button class="btn-cancel in-table-button" (click)="cancelEditCell()">
              <i class="material-icons">
                clear
              </i>
            </button>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef> </td>
      </ng-container>

      <ng-container matColumnDef="optimisticTime">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Optimistic Time </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <div class="cursor-pointer" *ngIf="i!=currentRowIndex || 'optimisticTime' != currentColumn"
            (dblclick)="doubleClick(i, 'optimisticTime', row.taskId)">
            {{row.optimisticTime}}
          </div>
          <div *ngIf="i===currentRowIndex && 'optimisticTime' === currentColumn">
            <input type="text" class="edit-input" #editData="ngModel" ngModel="{{row.optimisticTime}}">
            <button mat-icon-button class="btn-edit" (click)="saveEditCell(row.taskId,editData.control.value)">
              <i class="material-icons">
                done
              </i>
            </button>
            <button mat-icon-button class="btn-cancel" (click)="cancelEditCell()">
              <i class="material-icons">
                clear
              </i>
            </button>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef>{{getTotalCost('optimisticTime')}}</td>
      </ng-container>

      <ng-container matColumnDef="pessimisticTime">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Pessimistic Time </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <div class="cursor-pointer" *ngIf="i!=currentRowIndex || 'pessimisticTime' != currentColumn"
            (dblclick)="doubleClick(i, 'pessimisticTime', row.taskId)">
            {{row.pessimisticTime}}
          </div>
          <div *ngIf="i===currentRowIndex && 'pessimisticTime' === currentColumn">
            <input type="text" class="edit-input" #editData="ngModel" ngModel="{{row.pessimisticTime}}">
            <button mat-icon-button class="btn-edit" (click)="saveEditCell(row.taskId,editData.control.value)">
              <i class="material-icons">
                done
              </i>
            </button>
            <button mat-icon-button class="btn-cancel" (click)="cancelEditCell()">
              <i class="material-icons">
                clear
              </i>
            </button>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef>{{getTotalCost('pessimisticTime')}}</td>
      </ng-container>

      <ng-container matColumnDef="realTime">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Realistic Time </th>
        <td mat-cell *matCellDef="let row">{{row.realTime}}</td>
        <td mat-footer-cell *matFooterCellDef>{{getTotalCost('realTime')}}</td>
      </ng-container>

      <ng-container matColumnDef="pert">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Pert </th>
        <td mat-cell *matCellDef="let row">{{row.pert}}</td>
        <td mat-footer-cell *matFooterCellDef>{{getTotalCost('pert')}}</td>
      </ng-container>

      <ng-container matColumnDef="dateStart">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Estimate Start Date </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <div class="cursor-pointer" *ngIf="i!=currentRowIndex || 'dateStart' != currentColumn"
            (dblclick)="doubleClick(i, 'dateStart', row.taskId)">
            {{row.dateStart}}
          </div>
          <div *ngIf="i===currentRowIndex && 'dateStart' === currentColumn">
            <input type="date" class="edit-input" #editData="ngModel" ngModel="{{row.dateStart}}">
            <button mat-icon-button class="btn-edit" (click)="saveEditCell(row.taskId,editData.control.value)">
              <i class="material-icons">
                done
              </i>
            </button>
            <button mat-icon-button class="btn-cancel" (click)="cancelEditCell()">
              <i class="material-icons">
                clear
              </i>
            </button>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>

      <ng-container matColumnDef="endStart">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Estimate End Date</th>
        <td mat-cell *matCellDef="let row">{{row.endStart}}</td>
        <td mat-footer-cell *matFooterCellDef></td>
      </ng-container>

      <ng-container matColumnDef="completed">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Completed % </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <div class="cursor-pointer" *ngIf="i!=currentRowIndex || 'completed' != currentColumn"
            (dblclick)="doubleClick(i, 'completed', row.taskId)">
            {{row.completed}}
          </div>
          <div *ngIf="i===currentRowIndex && 'completed' === currentColumn">
            <mat-slider thumbLabel #editData tickInterval="1" [value]="row.completed" min="0" max="100">
            </mat-slider>
            <button mat-icon-button (click)="completedEditSave(row.taskId, editData.value)">
              <mat-icon class="btn-edit"> done </mat-icon>
            </button>
            <button (click)="cancelEditCell()" mat-icon-button>
              <mat-icon class="btn-cancel"> clear </mat-icon>
            </button>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef> </td>
      </ng-container>

      <ng-container matColumnDef="milestoneId">
        <th mat-header-cell *matHeaderCellDef mat-sort-header> Milestone </th>
        <td mat-cell *matCellDef="let row; let i = index">
          <span class="cursor-pointer" *ngIf="i!=currentRowIndex || 'milestoneId' != currentColumn"
            (dblclick)="doubleClick(i, 'milestoneId', row.taskId)">
            {{viewGetMilestoneName(row)}}</span>
          <div class="cursor-pointer" *ngIf="i===currentRowIndex && 'milestoneId' === currentColumn"
            class="assignee-cell">
            <ng-select class="select-width pl-3 d-inline-block" [multiple]="false" #editData="ngModel"
              [(ngModel)]="assignedMilestoneId">
              <ng-option *ngFor="let milestone of milestones" [value]="milestone.id"> {{milestone.name}} </ng-option>
            </ng-select>
            <div>
              <button mat-icon-button class="btn-edit in-table-button"
                (click)="saveEditCell(row.taskId,editData.control.value)">
                <i class="material-icons">
                  done
                </i>
              </button>
              <button mat-icon-button class="btn-cancel in-table-button" (click)="cancelEditCell()">
                <i class="material-icons">
                  clear
                </i>
              </button>
            </div>
          </div>
        </td>
        <td mat-footer-cell *matFooterCellDef> </td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
      <tr mat-row *matRowDef="let row; columns: displayedColumns;" cdkDrag [cdkDragData]="row"
        [cdkDragDisabled]="!!currentColumn.length || dragDisabled"></tr>
      <tr mat-footer-row *matFooterRowDef="displayedColumns"></tr>
    </table>
  </div>
</div>

<ng-template #addTaskDialog>
  <h1 mat-dialog-title>Add new task</h1>
  <div mat-dialog-content>
    <form autocomplete="off" (submit)="onAddTaskFormSubmit(addTask)" #addTask="ngForm">

      <div class="form-group">
        <label for="inputTaskName">Task name</label>
        <input type="text" class="form-control" id="inputTaskName" #inputTaskName="ngModel" name="inputTaskName" ngModel
          required>
        <div *ngIf="inputTaskName.invalid && (inputTaskName.touched || addTask.submitted)">
          <div *ngIf="inputTaskName.errors.required" class="input-err-text">Task name is required.</div>
        </div>
      </div>

      <div class="form-group">
        <label for="inputOptimisticTime">Optimistic time</label>
        <input type="number" min="0" class="form-control" id="inputOptimisticTime" #inputOptimisticTime="ngModel"
          name="inputOptimisticTime" ngModel required>
        <div *ngIf="inputOptimisticTime.invalid && (inputOptimisticTime.touched || addTask.submitted)">
          <div *ngIf="inputOptimisticTime.errors.required" class="input-err-text">Optimistic time is required.</div>
          <div *ngIf="inputOptimisticTime.errors.pattern" class="input-err-text">Optimistic time should be number</div>
        </div>
      </div>

      <div class="form-group">
        <label for="inputPessimisticTime">Pessimistic time</label>
        <input type="number" min="0" class="form-control" id="inputPessimisticTime" #inputPessimisticTime="ngModel"
          name="inputPessimisticTime" ngModel required>
        <div *ngIf="inputPessimisticTime.invalid && (inputPessimisticTime.touched || addTask.submitted)">
          <div *ngIf="inputPessimisticTime.errors.required" class="input-err-text">Pessimistic time is required.</div>
          <div *ngIf="inputPessimisticTime.errors.pattern" class="input-err-text">Pessimistic time should be number
          </div>
        </div>
      </div>
      <div mat-dialog-footer>
        <button mat-button cdkFocusInitial class="create-button">Add task</button>
      </div>
    </form>
  </div>
</ng-template>

<ng-template #exportSettings>
  <h1 mat-dialog-title>Select Columns you want NOT to Export</h1>
  <div mat-dialog-content>
    <div *ngFor="let column of exportColumns; let i = index">
      <mat-checkbox (change)="onOptionClick(i + 1)">{{column}}</mat-checkbox>
    </div>
    <div class="separator"></div>
    <mat-checkbox [checked]="exportGantt" [(ngModel)]="exportGantt">Export Gantt Chart</mat-checkbox>
    <div class="separator"></div>
    <div class="d-flex justify-content-center">
      <button class="add-task-button" mat-button (click)="exportHandler(exporter, 'csv', projectName)">Export
        in csv</button>
      <button class="add-task-button" mat-button (click)="exportHandler(exporter, 'xlsx', projectName)">Export
        in xlsx</button>
      <button class="add-task-button" mat-button (click)="exportHandler(exporter, 'xls', projectName)">Export
        in xls</button>
    </div>
  </div>
</ng-template>

<ng-template #pokerPlanningDialog>
  <form #createPockerPlanningForm="ngForm" autocomplete="off"
    (submit)="onCreatePockerPlanningFormSubmit(createPockerPlanningForm)">
    <h1 mat-dialog-title>Poker Planning - {{projectName}}</h1>
    <div mat-dialog-content class="pocker-dialog-body">

      <div class="form-group">
        <label for="taskSelect">Select Task </label>
        <ng-select appendTo="body" id="taskSelect" [multiple]="false" name="taskSelect"
          [(ngModel)]="pockerSelectedTaskId" #taskSelect="ngModel" required>
          <ng-option *ngFor="let task of dataSource.data" [value]="task.taskId"> {{task.taskId}} - {{task.taskName}}
          </ng-option>
        </ng-select>
        <div *ngIf="taskSelect.invalid && (taskSelect.touched || createPockerPlanningForm.submitted)">
          <div *ngIf="taskSelect.errors.required" class="input-err-text">Task is required.</div>
        </div>
      </div>

      <div *ngIf="!pockerSelectedTaskId" class="mt-4 mb-4"></div>

      <div *ngIf="pockerSelectedTaskId">

        <div class="form-group">
          <label for="taskDescription">Task Description (optional)</label>
          <input class="form-control" id="taskDescription" #taskDescription="ngModel" name="taskDescription" ngModel>
        </div>

        <div class="form-group">
          <label for="taskUrl">Task Url (optional)</label>
          <input class="form-control" id="taskUrl" #taskUrl="ngModel" name="taskUrl" ngModel>
        </div>

        <div class="form-group">
          <label for="inputCoefficient">Manager Сoefficient</label>
          <input type="number" min="1" class="form-control" id="inputCoefficient" #inputCoefficient="ngModel"
            name="inputCoefficient" ngModel required>
          <div *ngIf="inputCoefficient.invalid && (inputCoefficient.touched || createPockerPlanningForm.submitted)">
            <div *ngIf="inputCoefficient.errors.required" class="input-err-text">Manager Сoefficient is required.</div>
            <div *ngIf="inputCoefficient.errors.pattern" class="input-err-text">Manager Сoefficient should be number
            </div>
          </div>
        </div>

        <div class="form-group" *ngIf="!noDevelopersOnProject">
          <label for="developersSelect">Select Developers</label>
          <ng-select appendTo="body" [multiple]="true" id="developersSelect" bindLabel="taskBlockerName"
            bindValue="taskBlockerId" [(ngModel)]="pokerPlanningDevelopersIdArray" required>
            <ng-option *ngFor="let developer of developers" [value]="developer.userId">
              {{developer.firstName}} {{developer.lastName}}
            </ng-option>
          </ng-select>
        </div>

        <div *ngIf="noDevelopersOnProject">
          <div class="text-danger mb-3 mt-3"> No Developers in Project!</div>
        </div>
      </div>
    </div>

    <div mat-dialog-footer>
      <button [disabled]="noDevelopersOnProject" type="submit" class="create-button">Create</button>
    </div>
  </form>
</ng-template>